import java.util.List;
import java.util.stream.Stream;

List<?> flatten(List<?> list) {
  return list.stream().flatMap(
        e -> switch(e) {
          case List l -> flatten(l).stream();
          default -> Stream.of(e);
        }).toList();
}

void main() {
  var dim2 = List.of(
    List.of("a", "b", "c"),
    List.of("d", "e", "f"));
  var dim3 = List.of(
    List.of(
        List.of("a", "b", "c"),
        List.of("d", "e", "f")),
    List.of(
        List.of("g", "h", "i"),
        List.of("j", "k", "l")));
  System.out.println(flatten(dim2));
  System.out.println(flatten(dim3));
}
