# サンプルコードの記述について
本記事のサンプルはJava 21の機能を使っています。
Build 26以降で使えるようになっています。
https://jdk.java.net/21/

次のように`--enable-preview`と`--source 21`をつけることで`java`コマンドで実行できます。

```sh
> java --enable-preview --source 21 reccounter.java
```

withclassフォルダに、Java 20で実行可能なコードを置いています。flatten.javaについては`--enable-preview --source 20`が必要です。

以降、コードサンプルに対応するファイル名を載せていきます。

# 再帰


## 再帰によるループ

recloop.java

## 回数の決まった再帰

reccounter.java

## 入れ子になった状態遷移の再帰での処理

paren3.java


## 深さの変わるループ

multiply.java
flatten.java

## 分割統治法

quicksort.java

## メモ化再帰

steps1.java
stepsmemo.java

## 動的計画法

stepslooparray.java
stepsloop.java

## フィボナッチ数列と再帰

fib.java

# スタックとキュー

##  スタックと再帰

paren3stack.java

## キュー

movingavg.java

## 深さ優先探索と幅優先探索


### 再帰による深さ優先探索

traverserec.java

### スタックによる深さ優先探索

traversestack.java

### キューによる幅優先探索

traversequeue.java

## 優先度付キュー

pq.java

