import java.util.List;
import java.util.ArrayList;

record Node(int value, Node left, Node right) {
  Node(int value) {
    this(value, null, null);
  }
}

List<Integer> flatten(Node n) {
  var result = new ArrayList<Integer>();
  var deque = new ArrayList<Node>();
  deque.addLast(n);
  while (!deque.isEmpty()) {
    var node = deque.removeFirst();
    if (node == null) continue;
    result.add(node.value);
    deque.addLast(node.left);
    deque.addLast(node.right);
  }
  return result;
}

void main() {
  Node t = new Node(3,
             new Node(6, new Node(4),
                         new Node(7, null, new Node(5))),
             new Node(8, new Node(9, new Node(2), new Node(1)),
                         new Node(0)));
  System.out.println(flatten(t));
}
