import java.util.ArrayList;
import java.util.List;

record Node(int value, Node left, Node right) {
  Node(int value) { this(value, null, null); }
}

List<Integer> flatten(Node n) {
  return flatten(n, new ArrayList<>());
}

List<Integer> flatten(Node n, List<Integer> result) {
  if (n == null) return result;
  result.add(n.value);
  flatten(n.left, result);
  flatten(n.right, result);
  return result;
}

void main() {
  Node t = new Node(3,
             new Node(6, new Node(4),
                         new Node(7, null, new Node(5))),
             new Node(8, new Node(9, new Node(2), new Node(1)),
                         new Node(0)));
  System.out.println(flatten(t));
}
