import java.util.ArrayDeque;

public class Main {
  static void check(String str) {
    System.out.println("%s %s".formatted(str, checkImpl(str)));
  }
  static boolean checkImpl(String str) {
    var stack = new ArrayDeque<Character>();
    for (char ch : str.toCharArray()) {
      switch (ch) {
        case '(', '{', '[' -> {
          stack.push(ch);
        }
        case ')', '}', ']' -> {
          if (stack.isEmpty() || 
              stack.pop() != ch - (ch == ')' ? 1 : 2)) {
            return false;
          }
        }
      }
    }
    return stack.isEmpty();
  }
  public static void main(String[] args) {
    check("ab");
    check("()[]{}");
    check("a{b(c[d]e)f}g");
    check("a{b(c[d]e}f)g");
    check("ab)");
    check("a(b");
  }
}
